/* Copyright 2017, 2018 Kevin Ryde

   This file is part of nautyextra.

   nautyextra is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 3, or (at your option) any later
   version.

   nautyextra is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
   more details.

   You should have received a copy of the GNU General Public License along
   with nautyextra.  See the file COPYING.  If not, see
   <http://www.gnu.org/licenses/>.
*/

/* Search all trees using gentreeg for disjoint dominationg number count.

   gentreeg  num_vertices=2
   n=2  2 trees  max disjoint_domnum count 1 reps 2
   disjoint domnums 2, 2
   >>sparse6<<:An
   >>sparse6<<:An

   gentreeg  num_vertices=3
   n=3  1 trees  max disjoint_domnum count 1 reps 1
   disjoint domnum 3
   >>sparse6<<:BoN

   gentreeg  num_vertices=4
   n=4  2 trees  max disjoint_domnum count 2 reps 1
   disjoint domnum 4
   >>sparse6<<:Cpo

   gentreeg  num_vertices=5
   n=5  3 trees  max disjoint_domnum count 2 reps 1
   disjoint domnum 5
   >>sparse6<<:Dkj?^

   gentreeg  num_vertices=6
   n=6  6 trees  max disjoint_domnum count 4 reps 1
   disjoint domnum 6
   >>sparse6<<:EkWoq

   gentreeg  num_vertices=7
   n=7  11 trees  max disjoint_domnum count 5 reps 1
   disjoint domnum 6
   >>sparse6<<:FkioZB

   gentreeg  num_vertices=8
   n=8  23 trees  max disjoint_domnum count 8 reps 2
   disjoint domnums 8, 8
   >>sparse6<<:GoWs}On
   >>sparse6<<:GohbdO~

   gentreeg  num_vertices=9
   n=9  47 trees  max disjoint_domnum count 13 reps 1
   disjoint domnum 8
   >>sparse6<<:HgKSWRmWn

   gentreeg  num_vertices=10
   n=10  106 trees  max disjoint_domnum count 16 reps 3
   disjoint domnums 10, 10, 10
   >>sparse6<<:IiECjcoWg~
   >>sparse6<<:IiED`tD_xN
   >>sparse6<<:IiMSWWMWhN

   gentreeg  num_vertices=11
   n=11  235 trees  max disjoint_domnum count 33 reps 1
   disjoint domnum 10
   >>sparse6<<:JgMSWXO[uAD

   gentreeg  num_vertices=12
   n=12  551 trees  max disjoint_domnum count 33 reps 1
   disjoint domnum 11
   >>sparse6<<:KiIKKgMYXKIJ

   gentreeg  num_vertices=13
   n=13  1301 trees  max disjoint_domnum count 73 reps 1
   disjoint domnum 12
   >>sparse6<<:LiQ[gouhILFKV

   gentreeg  num_vertices=14
   n=14  3159 trees  max disjoint_domnum count 73 reps 2
   disjoint domnums 13, 13
   >>sparse6<<:MkECxZS[tAyWdF
   >>sparse6<<:MkUSWZERQrYQ_~

   gentreeg  num_vertices=15
   n=15  7741 trees  max disjoint_domnum count 161 reps 1
   disjoint domnum 14
   >>sparse6<<:NkUcxP`tatHwX@~

   gentreeg  num_vertices=16
   n=16  19320 trees  max disjoint_domnum count 181 reps 1
   disjoint domnum 14
   >>sparse6<<:OkSLGTfJjDiqbrB~

   gentreeg  num_vertices=17
   n=17  48629 trees  max disjoint_domnum count 337 reps 1
   disjoint domnum 16
   >>sparse6<<:PfEdcba`_nMLKJmIHGF

   gentreeg  num_vertices=18
   n=18  123867 trees  max disjoint_domnum count 473 reps 1
   disjoint domnum 16
   >>sparse6<<:QeDcba`_mLJIkHGlFoKE

   gentreeg  num_vertices=19
   n=19  317955 trees  max disjoint_domnum count 705 reps 1
   disjoint domnum 18
   >>sparse6<<:RgFedcba`_pONMLKoGJIH

   gentreeg  num_vertices=20
   n=20  823065 trees  max disjoint_domnum count 1089 reps 1
   disjoint domnum 18
   >>sparse6<<:SfBa`_dcnMIHlFGmKlJqPE

   gentreeg  num_vertices=21
   n=21  2144505 trees  max disjoint_domnum count 1441 reps 1
   disjoint domnum 20
   >>sparse6<<:ThGfedcba`_rQPONMqLKJIH

   gentreeg  num_vertices=22
   n=22  5623756 trees  max disjoint_domnum count 2481 reps 1
   disjoint domnum 20
   >>sparse6<<:UgFedcba`_qPJIoHGpNMsOLK

   gentreeg  num_vertices=23
   n=23  14828074 trees  max disjoint_domnum count 2945 reps 1
   disjoint domnum 22
   >>sparse6<<:ViHgfedcba`_tSRQPONsIMLKJ

   gentreeg  num_vertices=24
   n=24  39299897 trees  max disjoint_domnum count 5497 reps 1
   disjoint domnum 22
   >>sparse6<<:WhCba`_nEdgfsRQPmLKJmIHuRON

   gentreeg  num_vertices=25
   n=25  104636890 trees  max disjoint_domnum count 6759 reps 1
   disjoint domnum 22
   >>sparse6<<:XgBa`_dcferPJIoGHqNMpLoKvUQ

   gentreeg  num_vertices=26
   n=26  279793450 trees  max disjoint_domnum count 12177 reps 1
   disjoint domnum 24
   >>sparse6<<:YiHgfedcba`_uTRQPsONMtLKwSJI
   bistars 3,4 and 4,4 cross-connected at 3-4 middles

*/

#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <unistd.h>
#include <nauty/nauty.h>
#include <nauty/nausparse.h>
#include <nauty/naututil.h>
#include <nauty/gtools.h>
#include <nauty/gutils.h>

#include "nautyextra.h"
#include "nautyextra-wip.h"

#define WANT_DEBUG  0  /* set to 1 for debug prints */
#if WANT_DEBUG
#define DEBUG(expr)  expr
#else
#define DEBUG(expr)
#endif

int my_gentreeg_main(int argc, char**argv);

const int option_verbose = 0;

unsigned long long  trees_total_domnum[64];

#define MAX(x,y)  ((x) > (y) ? (x) : (y))
#define MIN(x,y)  ((x) < (y) ? (x) : (y))


int view_count = 0;
unsigned long long  tree_count = 0;
unsigned long long  max_value = 0;
int                 max_reps = 0;
#define  MAX_STRS_SIZE  100
char *max_strs[MAX_STRS_SIZE];
int disjoint_domnums[MAX_STRS_SIZE];
SG_DECL(sg);
SG_DECL(canon_sg);

void
my_gentreeg_outproc (FILE *outfile, int *vpar, int n)
{
  tree_count++;

  if (option_verbose) {
    printf("tree %p  n=%d\n", vpar,n);
    nautyextra_print_vpar(vpar,n);
  }

  struct nautyextra_disjoint_domnum_and_count info;
  nautyextra_disjoint_domnum_and_count_vpar(vpar,n,&info);

  if (info.count > max_value) {
    max_value = info.count;
    max_reps = 0;
  }
  if (info.count == max_value) {
    if (max_reps < MAX_STRS_SIZE) {
      if (max_strs[max_reps]) free(max_strs[max_reps]);
      nautyextra_vpar_to_sg(vpar,n, &sg, 0);
      nautyextra_canonise_sg(&sg,&canon_sg);
      max_strs[max_reps] = strdup(sgtos6(&canon_sg));
      disjoint_domnums[max_reps] = info.disjoint_domnum;
    }
    max_reps++;

#if 0
    printf("n=%d new high max_value %Lu  (at tree %Lu)\n",
           n, max_reps, tree_count);
#endif
  }

  if (NAUTYEXTRA_PROGRESS)
    printf("n=%d %Lu max %Lu count %d\r", n, tree_count, max_value, max_reps);
}

int
main (void)
{
  setbuf(stdout,NULL);
  nautyextra_view_synchronous = 1;
  nautyextra_want_progress = 1;

  SG_INIT(sg);
  SG_INIT(canon_sg);
  int num_vertices;
  for (num_vertices = 2;
       num_vertices <= 40;
       num_vertices += 1) {
    printf("gentreeg  num_vertices=%d\n", num_vertices);
    char num_vertices_str[20];
    sprintf(num_vertices_str, "%d", num_vertices);

    tree_count = 0;
    max_value = 0;
    max_reps = 0;

    int gentreeg_argc = 0;
    char *gentreeg_argv[10];
    gentreeg_argv[gentreeg_argc++] = "gentreeg"; /* progname */
    gentreeg_argv[gentreeg_argc++] = "-q";       /* quiet */
    gentreeg_argv[gentreeg_argc++] = num_vertices_str;
    gentreeg_argv[gentreeg_argc] = NULL;
    my_gentreeg_main(gentreeg_argc,gentreeg_argv);

    printf("n=%d  %Lu trees  max disjoint_domnum count %Lu reps %d \n",
           num_vertices, tree_count, max_value, max_reps);
    int i;
    int limit = MIN(max_reps,MAX_STRS_SIZE);
    printf("  disjoint domnum%s", max_reps==1?"":"s");
    for (i = 0; i < limit; i++)
      printf(" %d%s", disjoint_domnums[i], i==limit-1?"":",");
    printf("\n");
    for (i = 0; i < limit; i++)
      printf("%s%s",SPARSE6_HEADER, max_strs[i]);
    
    printf("\n");
  }

  return 0;
}
